searchNodes=[{"doc":"A logger wrapper to keep logger metadata of caller processes.","ref":"MetaLogger.html","title":"MetaLogger","type":"module"},{"doc":"Logs a debug message keeping logger metadata from caller processes. Returns :ok or an {:error, reason} tuple. Examples MetaLogger . debug ( &quot;hello?&quot; ) MetaLogger . debug ( fn -&gt; &quot;dynamically calculated debug&quot; end ) MetaLogger . debug ( fn -&gt; { &quot;dynamically calculated debug&quot; , [ additional : :metadata ] } end )","ref":"MetaLogger.html#debug/2","title":"MetaLogger.debug/2","type":"function"},{"doc":"Logs a error message keeping logger metadata from caller processes. Returns :ok or an {:error, reason} tuple. Examples MetaLogger . error ( &quot;hello?&quot; ) MetaLogger . error ( fn -&gt; &quot;dynamically calculated debug&quot; end ) MetaLogger . error ( fn -&gt; { &quot;dynamically calculated error&quot; , [ additional : :metadata ] } end )","ref":"MetaLogger.html#error/2","title":"MetaLogger.error/2","type":"function"},{"doc":"Logs a info message keeping logger metadata from caller processes. Returns :ok or an {:error, reason} tuple. Examples MetaLogger . info ( &quot;hello?&quot; ) MetaLogger . info ( fn -&gt; &quot;dynamically calculated debug&quot; end ) MetaLogger . info ( fn -&gt; { &quot;dynamically calculated info&quot; , [ additional : :metadata ] } end )","ref":"MetaLogger.html#info/2","title":"MetaLogger.info/2","type":"function"},{"doc":"Logs a message with given level keeping logger metadata from caller processes. Can accept a custom struct if it implements MetaLogger.Formatter protocol. Returns :ok or an {:error, reason} tuple. Examples MetaLogger . log ( :info , &quot;mission accomplished&quot; ) MetaLogger . log ( :error , fn -&gt; &quot;dynamically calculated info&quot; end ) MetaLogger . log ( :warn , fn -&gt; { &quot;dynamically calculated info&quot; , [ additional : :metadata ] } end )","ref":"MetaLogger.html#log/3","title":"MetaLogger.log/3","type":"function"},{"doc":"Logs a warn message keeping logger metadata from caller processes. Returns :ok or an {:error, reason} tuple. Examples MetaLogger . warn ( &quot;hello?&quot; ) MetaLogger . warn ( fn -&gt; &quot;dynamically calculated debug&quot; end ) MetaLogger . warn ( fn -&gt; { &quot;dynamically calculated warn&quot; , [ additional : :metadata ] } end )","ref":"MetaLogger.html#warn/2","title":"MetaLogger.warn/2","type":"function"},{"doc":"","ref":"MetaLogger.html#t:chardata_or_fun/0","title":"MetaLogger.chardata_or_fun/0","type":"type"},{"doc":"","ref":"MetaLogger.html#t:metadata/0","title":"MetaLogger.metadata/0","type":"type"},{"doc":"","ref":"MetaLogger.Formatter.html","title":"MetaLogger.Formatter","type":"protocol"},{"doc":"MetaLogger formatter protocol.","ref":"MetaLogger.Formatter.html#format/1","title":"MetaLogger.Formatter.format/1","type":"function"},{"doc":"","ref":"MetaLogger.Formatter.html#t:t/0","title":"MetaLogger.Formatter.t/0","type":"type"},{"doc":"Responsible for slicing log entries according to the given max length option.","ref":"MetaLogger.Slicer.html","title":"MetaLogger.Slicer","type":"module"},{"doc":"Returns sliced log entries according to the given max entry length. If the entry is smaller than given max length, or if :infinity is given as option, a list with one entry is returned. Otherwise a list with multiple entries is returned. Examples iex&gt; MetaLogger.Slicer . slice ( &quot;1234567890&quot; , 10 ) [ &quot;1234567890&quot; ] iex&gt; MetaLogger.Slicer . slice ( &quot;1234567890&quot; , :infinity ) [ &quot;1234567890&quot; ] iex&gt; MetaLogger.Slicer . slice ( &quot;1234567890&quot; , 5 ) [ &quot;12345&quot; , &quot;67890&quot; ]","ref":"MetaLogger.Slicer.html#slice/2","title":"MetaLogger.Slicer.slice/2","type":"function"},{"doc":"Max length in bytes or :infinity if the entry should not be sliced.","ref":"MetaLogger.Slicer.html#t:max_entry_length/0","title":"MetaLogger.Slicer.max_entry_length/0","type":"type"},{"doc":"Tesla middleware to log requests and responses. You can pass the options to the middleware or to the request Tesla.Env , env options takes precedence over middleware options. Example usage defmodule MyClient do use Tesla plug Tesla.Middleware.MetaLogger, filter_body : [ { ~r/&quot;email&quot;:&quot;.*?&quot;/ , ~s(&quot;email&quot;:&quot;[FILTERED]&quot;) } ] , filter_headers : [ &quot;authorization&quot; ] , filter_query_params : [ :api_key ] , log_level : :debug , log_tag : MyApp , max_entry_length : :infinity end Options :filter_headers - The headers that should not be logged, the values will be replaced with [FILTERED] , defaults to: [] . :filter_query_params - The query params that should not be logged, the values will be replaced with [FILTERED] , defaults to: [] :filter_body - The request and response body patterns that should not be logged, each filter can be just a pattern, wich will be replaced by &quot;[FILTERED]&quot; , or it can be a tuple with the pattern and the replacement. Because the body filtering is applied to strings it is necessary that this middleware is the last one on the stack, so it receives the request body already encoded and the response body not yet decoded. If the body is not a string, the filtering will be skipped. :log_level - The log level to be used, defaults to: :info . Responses with HTTP status 400 and above will be logged with :error , and redirect with :warn . :log_tag - The log tag to be prefixed in the logs, default to: Tesla.Middleware.MetaLogger . max_entry_length - The maximum length of a log entry before it is splitted into new ones. Defaults to :infinity .","ref":"Tesla.Middleware.MetaLogger.html","title":"Tesla.Middleware.MetaLogger","type":"module"},{"doc":"","ref":"MetaLogger.Formatter.IncorrectOrNotSetFormatterFunction.html","title":"MetaLogger.Formatter.IncorrectOrNotSetFormatterFunction","type":"exception"},{"doc":"","ref":"MetaLogger.Formatter.IncorrectPayload.html","title":"MetaLogger.Formatter.IncorrectPayload","type":"exception"},{"doc":"MetaLogger Wrapper for Elixir.Logger that keeps logger metadata from caller processes.","ref":"readme.html","title":"MetaLogger","type":"extras"},{"doc":"MetaLogger requires Elixir 1.10 or greater. For previous versions use MetaLogger 0.1.0 . The package is available in Hex , and can be installed by adding meta_logger to your list of dependencies in mix.exs : def deps do [ { :meta_logger , &quot;~&gt; 1.4.1&quot; } ] end Documentation is generated with ExDoc and published on HexDocs . The docs can be found at https://hexdocs.pm/meta_logger .","ref":"readme.html#installation","title":"MetaLogger - Installation","type":"extras"},{"doc":"Just replace Logger with MetaLogger , there's no need to require it before using: MetaLogger . [ debug | error | info | log | warn ] ( ... )","ref":"readme.html#usage","title":"MetaLogger - Usage","type":"extras"},{"doc":"Logs requests and responses.","ref":"readme.html#tesla-middleware","title":"MetaLogger - Tesla Middleware","type":"extras"},{"doc":"Optionally MetaLogger requires another two dependencies, if you want to use the Tesla middleware, add those dependencies to your mix.exs : def deps do [ { :tesla , &quot;~&gt; 1.4&quot; } , { :miss , &quot;~&gt; 0.1&quot; } , ] end Example usage defmodule MyClient do use Tesla plug \#{inspect(__MODULE__)}, filter_body : { ~r/email=.*&amp;/ , &quot;email=[FILTERED]&amp;&quot; } filter_headers : [ &quot;authorization&quot; ] , filter_query_params : [ :api_key ] , log_level : :debug , log_tag : MyApp , max_entry_length : 22_000 end Options :filter_headers - The headers that should not be logged, the values will be replaced with [FILTERED] , defaults to: [] . :filter_query_params - The query params that should not be logged, the values will be replaced with [FILTERED] , defaults to: [] . :filter_body - The request and response body patterns that should not be logged, each filter can be just a pattern, wich will be replaced by &quot;[FILTERED]&quot; , or it can be a tuple with the pattern and the replacement. Because the body filtering is applied to strings it is necessary that this middleware is the last one on the stack, so it receives the request body already encoded and the response body not yet decoded. If the body is not a string, the filtering will be skipped. :log_level - The log level to be used, defaults to: :info . Responses with HTTP status 400 and above will be logged with :error , and redirect with :warn . :log_tag - The log tag to be prefixed in the logs, default to: \#{inspect(__MODULE__)} . max_entry_length - The maximum length of a log entry before it is splitted into new ones. Defaults to :infinity .","ref":"readme.html#installation","title":"MetaLogger - Installation","type":"extras"},{"doc":"It is possible to define an implementation for a custom struct, so MetaLogger will know how to format log messages. It also includes the possibility to filter some data using regexp patterns. It could be useful, when there is defined a struct with sensitive information, for example after an HTTP request. If you own the struct, you can derive the implementation specifying a formatter function and patterns which will be filtered. The struct for which implementation will be used must have payload field which is used as input for defined format function. MetaLogger.log/3 accepts the structs which derives MetaLogger.Formatter implementation. Usage defmodule ClientFormatterImpl do @derive { MetaLogger.Formatter , formatter_fn : &amp; __MODULE__ . format / 1 , filter_patterns : [ { ~s/&quot;name&quot;:&quot;.*&quot;/ , ~s/&quot;name&quot;:&quot;[FILTERED]&quot;/ } , &quot;very_secret_word&quot; ] } def build ( payload ) do struct! ( __MODULE__ , payload : payload ) end def format ( %{ foo : foo } ) do &quot;Very useful but filtered information: \#{ inspect ( foo ) } &quot; end end # Using it: http_request # Inside the build function a logic can be defined to extract an useful payload which # needs to be logged, e.g. a request and response information. |&gt; ClientFormatterImpl . build ( ) |&gt; then ( fn log_struct -&gt; MetaLogger . log ( :debug , log_struct ) end ) Options :formatter_fn (required) - The function which is used to format a given payload. The function must return a string or a list of strings. :filter_patterns (optional) - Regex patterns which will be used to replace sensitive information in a payload. It is a list of strings or tuples (can be mixed). If tuples are given, the first element is used as a regex pattern to match, and the second is as a replacement which will be used to replace it, e.g. {~s/&quot;name&quot;: &quot;.+&quot;/, ~s/&quot;name&quot;: &quot;[FILTERED]&quot;/} .","ref":"readme.html#metalogger-formatter-protocol","title":"MetaLogger - MetaLogger.Formatter protocol","type":"extras"},{"doc":"After merge a new feature/bug you can bump and publish it with: make release make publish","ref":"readme.html#release","title":"MetaLogger - Release","type":"extras"},{"doc":"meta_logger source code is released under Apache 2 License. Check the LICENSE file for more information.","ref":"readme.html#license","title":"MetaLogger - License","type":"extras"},{"doc":"Changelog All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Changed Update ex_doc .","ref":"changelog.html#1-4-1-2021-06-21","title":"Changelog - 1.4.1 - 2021-06-21","type":"extras"},{"doc":"Added Add MetaLogger.Slicer to slice log entries. Add body filtering to Tesla Middleware. Slice log entries on Tesla Middleware.","ref":"changelog.html#1-4-0-2021-06-21","title":"Changelog - 1.4.0 - 2021-06-21","type":"extras"},{"doc":"Added Custom replacements for filter patterns.","ref":"changelog.html#1-3-1-2021-06-03","title":"Changelog - 1.3.1 - 2021-06-03","type":"extras"},{"doc":"Added Add MetaLogger.Formatter protocol. log\\3 accepts a list as the payload. Each element of the list will be logged separately.","ref":"changelog.html#1-3-0-2021-06-02","title":"Changelog - 1.3.0 - 2021-06-02","type":"extras"},{"doc":"Added Add query params filtering to Tesla Middleware. Changed Ensure Tesla is loaded before defining MetaLogger middleware to avoid compilation errors on projects without Tesla.","ref":"changelog.html#1-2-0-2021-04-23","title":"Changelog - 1.2.0 - 2021-04-23","type":"extras"},{"doc":"Added Add Tesla middleware to log requests and responses. Changed Moved from Travis CI to GitHub Actions.","ref":"changelog.html#1-1-0-2020-12-16","title":"Changelog - 1.1.0 - 2020-12-16","type":"extras"},{"doc":"Changed Changes the required version of Elixir from 1.9 to 1.10. Fixed Gets logger metadata from the correct process dictionary key. Elixir 1.10 uses Erlang logger metadata.","ref":"changelog.html#1-0-0-2020-07-14","title":"Changelog - 1.0.0 - 2020-07-14","type":"extras"},{"doc":"Added Keep logger metadata from caller processes.","ref":"changelog.html#0-1-0-2019-09-13","title":"Changelog - 0.1.0 - 2019-09-13","type":"extras"}]